/* .c                         freeware                 xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xahfile.h"

/* ------------------------------ FUNCTION -------------------------  */
/* Do    :                                      */
/*                             */
/* Call  :                                                            */
/* Debug :
/* -------------------------------------------------------------------------- */
aplsb_C(int n,int p)
{
int      i;
int      j;
fraction a;
fraction b;
fraction aplsb;

double pC      [n][p*TWOCOL];matrix mC      ={n,p*TWOCOL,&pC      [0][0]};
double paC     [n][p*TWOCOL];matrix maC     ={n,p*TWOCOL,&paC     [0][0]};
double pbC     [n][p*TWOCOL];matrix mbC     ={n,p*TWOCOL,&pbC     [0][0]};
double paplsb_C[n][p*TWOCOL];matrix maplsb_C={n,p*TWOCOL,&paplsb_C[0][0]};
double paCplsbC[n][p*TWOCOL];matrix maCplsbC={n,p*TWOCOL,&paCplsbC[0][0]};

double paplsb_C_mns_aCplsbC[n][p*TWOCOL];
matrix maplsb_C_mns_aCplsbC={n,p*TWOCOL,&paplsb_C_mns_aCplsbC[0][0]};

/*-------------------------------- PROGRAM ---------------------------------- */
  a.numer = (int)     (randF(9)+1);
  a.denom = (int) fabs(randF(9)+1);
  b.numer = (int)     (randF(9)+1);
  b.denom = (int) fabs(randF(9)+1);

  randmF(&mC,10,9);

  clrscrn();
  printf("                                                      ");
  printf("a = %.0f/%.0f\n\n",
          a.numer,
          a.denom);
  printf("                                                      ");
  printf("b = %.0f/%.0f\n\n",
          b.numer,
          b.denom);
  printf("                                                      C  :");
  printmF4(&mC);
  getchar();

  clrscrn();
  aplsb = addF(a,b);
  printf("                                      ");
  printf(" a + b = %.0f/%.0f + (%.0f/%.0f) = %.0f/%.0f\n\n",
              a.numer,    a.denom,
              b.numer,    b.denom,
          aplsb.numer,aplsb.denom);
  printf("                                                       C :");
  printmF4( &mC);
  printf("                                                 (a+b)C :\n");
  smultmF(aplsb,&mC,&maplsb_C);
  printmF4(         &maplsb_C);
  getchar();

  clrscrn();
  printf("                                                      ");
  printf("a = %.0f/%.0f\n\n",
          a.numer,
          a.denom);
  printf("                                                       C :");
  printmF4( &mC);
  printf("                                                      aC :\n");
  smultmF(a,&mC,&maC);
  printmF4(     &maC);
  getchar();

  clrscrn();
  printf("                                                      ");
  printf("b = %.0f/%.0f\n\n",
          b.numer,
          b.denom);
  printf("                                                       C :");
  printmF4( &mC);
  printf("                                                      bC :\n");
  smultmF(b,&mC,&mbC);
  printmF4(     &mbC);
  getchar();


  clrscrn();
  printf("                                                     aC  :");
  printmF4(&maC);
  printf("                                                     bC  :");
  printmF4(&mbC);
  printf("\n                                                 (aC+bC) :");
  addmF(&maC,&mbC,&maCplsbC);
  printmF4(       &maCplsbC);
  getchar();

  clrscrn();
  printf("                                                 (a+c)C  :");
  printmF4(&maplsb_C);
  printf("\n                                                 (aC+bC) :");
  printmF4(       &maCplsbC);
  printf("\n                                      ((a+c)C) - (aC+bC) :");
  submF(&maplsb_C,&maCplsbC,&maplsb_C_mns_aCplsbC);
  printmF4(                 &maplsb_C_mns_aCplsbC);
}


void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n                                                  ");
  printf("\n            (a+c)C = aC+bC                        ");
  printf("\n            **************                      \n");
  printf("\n The size of  mC         : 1x1 ... 5x5.         \n");
  printf("\n     ex : \"pjf.exe\"                           \n");
  printf("\n You can choose the size :                      \n");
  printf("\n     ex : \"pjf.exe 2 3\" -> 2x3                  ");
  printf("\n          \"pjf.exe 1 5\" -> 1x5                  ");
  printf("\n          \"pjf.exe 4 2\" -> 4x2                  ");
  printf("\n          \"pjf.exe 5 5\" -> 5x5                  ");
  printf("\n\n                                                ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press a key to continue                          ");
  printf("\n                                                  ");
  getchar();
}

/* --------------------------------- MAIN ----------------------------------- */
main(int argc, char *argv[])
{
time_t t;
int    n;
int    p;

  srand(time(&t));
  hello();

do
{
if( argc == 3 && atoi(argv[1])&& atoi(argv[2]) )
 {
  n = atoi(argv[1]);
  p = atoi(argv[2]);

  if( n < 1){n=1;}
  if( n > 5){n=5;}
  if( p < 1){p=1;}
  if( p > 5){p=5;}
 }
else
 {
  n = (int) fabs(randF(5)+1);
  p = (int) fabs(randF(5)+1);
 }

  aplsb_C(n,p);

  printf("\n Press 'X' Return to stop\n");

} while(toupper(getchar())!='X');

  return 0;
}












